#######################################################################
#
#    Dream-Explorer for Dreambox-Enigma2
#    Release: 1.5
#    Coded by Vali (c)2008
#    Support: www.dreambox-tools.info
#
#    This program is free software; you can redistribute it and/or
#    modify it under the terms of the GNU General Public License
#    as published by the Free Software Foundation; either version 2
#    of the License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#######################################################################



from Plugins.Plugin import PluginDescriptor
from Screens.Screen import Screen
from Screens.InfoBar import MoviePlayer
from Screens.Console import Console
from Screens.ChoiceBox import ChoiceBox
from Components.ActionMap import ActionMap
from Components.FileList import FileList
from Components.Label import Label
from Components.ScrollLabel import ScrollLabel
from Components.Pixmap import Pixmap
from Components.AVSwitch import AVSwitch
from Components.ServiceEventTracker import ServiceEventTracker
from enigma import eConsoleAppContainer, eServiceReference, eTimer, ePicLoad, getDesktop, iPlayableService
from os import system as os_system
from os import stat as os_stat
from os import walk as os_walk
from random import randint




def main(session, **kwargs):
	session.open(DreamExplorer)



def Plugins(**kwargs):
 	return [PluginDescriptor(name="Dream-Explorer", description="EXPLORE YOUR DREAMBOX ...", where = PluginDescriptor.WHERE_PLUGINMENU, fnc=main),
			PluginDescriptor(name="Dream-Explorer", description="EXPLORE YOUR DREAMBOX ...", where = PluginDescriptor.WHERE_EXTENSIONSMENU, fnc=main)]



######## DREAM-EXPLORER START#######################

HDSkn = False
class DreamExplorer(Screen):
	skin = """
	<screen position="50,50" size="620,476" title="Dream-Explorer" flags="wfNoBorder" backgroundColor="#FFFFFFFF">
		<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/DreamExplorer/ex_bg1.png" zPosition="2" position="0,0" size="620,476" transparent="1" alphatest="off" />
		<widget name="filelist" position="7,34" size="606,402" backgroundColor="#222C2C39" scrollbarMode="showOnDemand" zPosition="4"/>
		<widget name="location" position="0,439" size="620,36" font="Regular;16" foregroundColor="#f0f0f0" backgroundColor="#302C2C39" zPosition="4" halign="center" valign="center" transparent="1"/>
	</screen>"""
	global HDSkn
	try:
		sz_w = getDesktop(0).size().width()
		if sz_w == 1280:
			HDSkn = True
		else:
			HDSkn = False
	except:
		HDSkn = False
	def __init__(self, session, args = None):
		self.skin = DreamExplorer.skin
		Screen.__init__(self, session)
		self.sesion = session
		self["location"] = Label(_("Starting up.."))
		self["filelist"] = FileList("/", showDirectories = True, showFiles = True, matchingPattern = "^.*\.*", useServiceRef = False)
		self["actions"] = ActionMap(["WizardActions", "DirectionActions"],
		{
			"ok": self.ok,
			"back": self.close,
			"left": self.left,
			"right": self.right,
			"up": self.up,
			"down": self.down
		}, -1)
		self.onLayoutFinish.append(self.byLayoutEnd)

	def ok(self):
		if self["filelist"].canDescent():
			self["filelist"].descent()
			self.updateLocationInfo()
		else:
			filename = self["filelist"].getCurrentDirectory() + self["filelist"].getFilename()
			testFileName = self["filelist"].getFilename()
			testFileName = testFileName.lower()
			if filename != None:
				if testFileName.endswith(".ts"):
					fileRef = eServiceReference("1:0:0:0:0:0:0:0:0:0:" + filename)
					self.session.open(ExPlayer, fileRef)
				elif (testFileName.endswith(".mpg")) or (testFileName.endswith(".mpeg")) or (testFileName.endswith(".avi")):
					fileRef = eServiceReference("4097:0:0:0:0:0:0:0:0:0:" + filename)
					self.session.open(ExPlayer, fileRef)
				elif (testFileName.endswith(".mkv")) or (testFileName.endswith(".mp4")):
					fileRef = eServiceReference("4097:0:0:0:0:0:0:0:0:0:" + filename)
					self.session.open(ExPlayer, fileRef)
				elif (testFileName.endswith(".mp3")) or (testFileName.endswith(".wav")) or (testFileName.endswith(".ogg")):
					fileRef = eServiceReference("4097:0:0:0:0:0:0:0:0:0:" + filename)
					self.session.open(ExPlayer, fileRef, True)
				elif (testFileName.endswith(".jpg")) or (testFileName.endswith(".jpeg")) or (testFileName.endswith(".png")) or (testFileName.endswith(".bmp")):
					self.session.open(PictureExplorer, filename)
				elif testFileName.endswith(".tar.gz"):
					self.commando = [ "tar -xzvf " + filename + " -C /" ]
					askList = [(_("Cancel"), "NO"),(_("Install this package"), "YES")]
					self.session.openWithCallback(self.SysExecution, ChoiceExplorer, title=_("GZ-package:\\n"+filename), list=askList)
				elif testFileName.endswith(".tar.bz2"):
					self.commando = [ "tar -xjvf " + filename + " -C /" ]
					askList = [(_("Cancel"), "NO"),(_("Install this package"), "YES")]
					self.session.openWithCallback(self.SysExecution, ChoiceExplorer, title=_("BZ2-package:\\n"+filename), list=askList)
				elif testFileName.endswith(".ipk"):
					self.commando = [ "ipkg install " + filename ]
					askList = [(_("Cancel"), "NO"),(_("Install this package"), "YES")]
					self.session.openWithCallback(self.SysExecution, ChoiceExplorer, title=_("IPKG-package:\\n"+filename), list=askList)
				elif testFileName.endswith(".sh"):
					self.commando = [ filename ]
					askList = [(_("Cancel"), "NO"),(_("View this file"), "VIEW"),(_("Start execution"), "YES")]
					self.session.openWithCallback(self.SysExecution, ChoiceExplorer, title=_("Do you want to execute?\\n"+filename), list=askList)
				elif testFileName.endswith(".party"):
					self.LetsGoPartyNow(filename)
				else:
					xfile=os_stat(filename)
					if (xfile.st_size < 100000):
						self.session.open(FileExplorer, filename)

	def byLayoutEnd(self):
		self.updateLocationInfo()

	def updateLocationInfo(self):
		self["location"].setText(_(self["filelist"].getCurrentDirectory()))

	def SysExecution(self, answer):
		answer = answer and answer[1]
		if answer == "YES":
			self.session.open(SysOutView, self.commando[0])
		elif answer == "VIEW":
			yfile=os_stat(self.commando[0])
			if (yfile.st_size < 100000):
				self.session.open(FileExplorer, self.commando[0])

	def up(self):
		self["filelist"].up()
		self.updateLocationInfo()

	def down(self):
		self["filelist"].down()
		self.updateLocationInfo()

	def left(self):
		self["filelist"].pageUp()
		self.updateLocationInfo()

	def right(self):
		self["filelist"].pageDown()
		self.updateLocationInfo()

	def LetsGoPartyNow(self, partyfile):
		partylines = []
		try:
			plines = open(partyfile, "r")
			for oneline in plines:
				partylines.append(oneline)
			plines.close()
			partyPictures = partylines[0][:-1]
			partyMusik = partylines[1][:-1]
			self.session.open(PartyTime, partyPictures, partyMusik)
		except:
			print "Party-file ERROR."

######## DREAM-EXPLORER END####################### 



class FileExplorer(Screen):
	skin = """
	<screen position="50,50" size="620,476" title="File-Explorer" flags="wfNoBorder" backgroundColor="#FFFFFFFF">
		<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/DreamExplorer/ex_bg1.png" zPosition="-2" position="0,0" size="620,476" transparent="1" alphatest="off" />
		<eLabel position="7,34" size="606,402" backgroundColor="#222C2C39" zPosition="-1" />
		<widget name="filedata" position="7,34" size="606,402" backgroundColor="#222C2C39" font="Regular;16" foregroundColor="#f0f0f0" zPosition="9" transparent="1"/>
		<widget name="status" position="0,439" size="620,36" font="Regular;16" foregroundColor="#f0f0f0" backgroundColor="#302C2C39" zPosition="4" halign="center" valign="center" transparent="1"/>
	</screen>"""
	def __init__(self, session, file):
		self.skin = FileExplorer.skin
		Screen.__init__(self, session)
		self.file_name = file
		self["status"] = Label(_(file))
		self["filedata"] = ScrollLabel("Read file. Please wait...")
		self.filetext = ""
		self["actions"] = ActionMap(["WizardActions"],
		{
			"ok": self.close,
			"back": self.close,
			"left": self["filedata"].pageUp,
			"right": self["filedata"].pageDown,
			"up": self["filedata"].pageUp,
			"down": self["filedata"].pageDown
		}, -1)
		self.onLayoutFinish.append(self.ViewFileLines)

	def GetFileData(self, fx):
		xxflines = []
		try:
			flines = open(fx, "r")
			for line in flines:
				xxflines.append(line)
			flines.close()
			self.filetext = ''.join(xxflines)
		except:
			return 'Read Error.'

	def ViewFileLines(self):
		self.GetFileData(self.file_name)
		self["filedata"].setText(self.filetext)



class SysOutView(Console):
	skin = """
	<screen position="50,50" size="620,476" title="Systen-Viewer" flags="wfNoBorder" backgroundColor="#FFFFFFFF">
		<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/DreamExplorer/ex_bg1.png" zPosition="-2" position="0,0" size="620,476" transparent="1" alphatest="off" />
		<eLabel position="7,34" size="606,402" backgroundColor="#222C2C39" zPosition="-1" />
		<widget name="text" position="7,34" size="606,402" backgroundColor="#222C2C39" font="Regular;16" foregroundColor="#f0f0f0" zPosition="9" transparent="1"/>
		<widget name="status" position="0,439" size="620,36" font="Regular;16" foregroundColor="#f0f0f0" backgroundColor="#302C2C39" zPosition="4" halign="center" valign="center" transparent="1"/>
	</screen>"""
	def __init__(self, session, os_commando):
		Console.skin = SysOutView.skin
		Console.__init__(self, session, title = "SysOutView", cmdlist = [ os_commando ])
		self["status"] = Label(_(os_commando))



class PictureExplorer(Screen):
	global HDSkn
	if HDSkn:
		skin="""
			<screen name="PictureExplorer" flags="wfNoBorder" position="0,0" size="1280,720" title="Picture-Explorer" backgroundColor="#2C2C39">
				<widget name="Picture" position="0,0" size="1280,720" zPosition="1" transparent="1" />
			</screen>"""
	else:
		skin="""
			<screen name="PictureExplorer" flags="wfNoBorder" position="0,0" size="720,576" title="Picture-Explorer" backgroundColor="#002C2C39">
				<widget name="Picture" position="0,0" size="720,576" zPosition="1" alphatest="on" />
			</screen>"""
	def __init__(self, session, whatPic = None):
		self.skin = PictureExplorer.skin
		Screen.__init__(self, session)
		self.whatPic = whatPic
		self.EXscale = (AVSwitch().getFramebufferScale())
		self.EXpicload = ePicLoad()
		self["Picture"] = Pixmap()
		self["actions"] = ActionMap(["WizardActions"],
		{
			"ok": self.close,
			"back": self.close
		}, -1)
		self.EXpicload.PictureData.get().append(self.DecodeAction)
		self.onLayoutFinish.append(self.Show_Picture)

	def Show_Picture(self):
		if self.whatPic is not None:
			self.EXpicload.setPara([self["Picture"].instance.size().width(), self["Picture"].instance.size().height(), self.EXscale[0], self.EXscale[1], 0, 1, "#002C2C39"])
			self.EXpicload.startDecode(self.whatPic)

	def DecodeAction(self, pictureInfo=""):
		if self.whatPic is not None:
			ptr = self.EXpicload.getData()
			self["Picture"].instance.setPixmap(ptr)



class ExPlayer(MoviePlayer):
	skin="""
	<screen name="ExPlayer" flags="wfNoBorder" position="3,30" size="720,576" title="ExPlayer-Bar" backgroundColor="#FFFFFFFF">
		<ePixmap position="41,388" zPosition="-1" size="630,130" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/DreamExplorer/ExPlayer.png" alphatest="off" transparent="1"/>
		<ePixmap position="285,471" zPosition="2" size="150,20" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/DreamExplorer/dvr.png" alphatest="on" />
		<widget source="session.CurrentService" render="Label" position="50,404" size="610,59" valign="center" halign="center" zPosition="3" font="Regular;21" foregroundColor="#F0F0F0" backgroundColor="#302C2C39" >
			<convert type="ServiceName">Name</convert>
		</widget>
		<widget source="session.CurrentService" render="Label" position="440,468" size="200,26" font="Regular;22" halign="right" backgroundColor="#302C2C39" foregroundColor="#F0F0F0" zPosition="3" transparent="1" >
			<convert type="ServicePosition">Length</convert>
		</widget>
		<widget source="session.CurrentService" render="Label" position="80,467" size="200,30" font="LCD;27" halign="left" backgroundColor="#302C2C39" foregroundColor="#FCC000" zPosition="3" transparent="1" >
			<convert type="ServicePosition">Position</convert>
		</widget>
		<widget source="session.CurrentService" render="PositionGauge" position="64,393" size="584,12" zPosition="3" pointer="/usr/lib/enigma2/python/Plugins/Extensions/DreamExplorer/position_pointer.png:572,0" transparent="1" >
			<convert type="ServicePosition">Gauge</convert>
		</widget>
	</screen>"""
	def __init__(self, session, service, musik=False):
		self.skin = ExPlayer.skin
		self.session = session
		self.visualizer = eTimer()
		self.visualizer.callback.append(self.Visulisierung)
		if musik:
			self.visualizer.start(5000, True)
		self.altservice = self.session.nav.getCurrentlyPlayingServiceReference()
		MoviePlayer.__init__(self, session, service)

	def leavePlayer(self):
		self.is_closing = True
		self.session.nav.playService(self.altservice)
		self.close()

	def leavePlayerConfirmed(self, answer):
		pass

	def doEofInternal(self, playing):
		if not self.execing:
			return
		if not playing :
			return
		self.leavePlayer()

	def showMovies(self):
		pass

	def movieSelected(self, service):
		self.leavePlayer()

	def Visulisierung(self):
		self.visualizer.stop()
		rndMvi = randint(1,4)
		os_system("/usr/bin/showiframe /usr/lib/enigma2/python/Plugins/Extensions/DreamExplorer/saver/"+str(rndMvi)+".mvi")



class ChoiceExplorer(ChoiceBox):
	skin = """
	<screen position="50,50" size="620,476" title="Choice-Explorer" flags="wfNoBorder" backgroundColor="#FFFFFFFF">
		<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/DreamExplorer/ex_bg1.png" zPosition="-1" position="0,0" size="620,476" transparent="1" alphatest="off" />
		<widget name="list" position="7,235" size="606,201" backgroundColor="#222C2C39" scrollbarMode="showOnDemand" zPosition="0"/>
		<widget name="text" position="7,34" size="606,201" font="Regular;22" foregroundColor="#FCC000" backgroundColor="#222C2C39" zPosition="9" halign="center" valign="center" />
	</screen>"""
	def __init__(self, session, title = "", list = [], keys = None, selection = 0):
		ChoiceBox.__init__(self, session, title, list, keys, selection)



class PartyTime(Screen):
	global HDSkn
	if HDSkn:
		skin="""
			<screen name="PartyTime" flags="wfNoBorder" position="0,0" size="1280,720" title="Party-Time" backgroundColor="#2C2C39">
				<widget name="Picture" position="0,0" size="1280,720" zPosition="1" transparent="1" />
			</screen>"""
	else:
		skin="""
			<screen name="PartyTime" flags="wfNoBorder" position="0,0" size="720,576" title="Party-Time" backgroundColor="#2C2C39">
				<widget name="Picture" position="0,0" size="720,576" zPosition="1" transparent="1" />
			</screen>"""
	def __init__(self, session, PicDir = None, MusikDir = None):
		self.skin = PartyTime.skin
		self.session = session
		Screen.__init__(self, session)
		self.PicDir = PicDir
		self.MusikDir = MusikDir
		self.EXscale = (AVSwitch().getFramebufferScale())
		self.EXpicload = ePicLoad()
		self["Picture"] = Pixmap()
		self.NextPicTimer = eTimer()
		self.NextPicTimer.callback.append(self.showRandomPicture)
		self["actions"] = ActionMap(["WizardActions"],
		{
			"ok": self.PartyEnd,
			"back": self.PartyEnd
		}, -1)
		self.altservice = self.session.nav.getCurrentlyPlayingServiceReference()
		self.service = self.CallRandomService()
		if self.service is not None:
			self.session.nav.playService(self.service)
		self.__event_tracker = ServiceEventTracker(screen=self, eventmap=
			{
				iPlayableService.evEOF: self.findNewService
			})
		self.EXpicload.PictureData.get().append(self.DecodeAction)
		self.onLayoutFinish.append(self.ShowOnePicture)

	def ShowOnePicture(self):
		if (self.PicDir is not None) and (self.MusikDir is not None):
			self.EXpicload.setPara([self["Picture"].instance.size().width(), self["Picture"].instance.size().height(), self.EXscale[0], self.EXscale[1], 0, 0, "#002C2C39"])
			self.NextPicTimer.start(5000, True)
		else:
			self.PartyEnd()

	def PartyEnd(self):
		self.NextPicTimer.stop()
		self.session.nav.playService(self.altservice)
		self.close()

	def findNewService(self):
		self.service = self.CallRandomService()
		if self.service is not None:
			self.session.nav.playService(self.service)
		else:
			self.PartyEnd()

	def CallRandomService(self):
		if (self.PicDir is not None) and (self.MusikDir is not None):
			srvList = []
			for root, dirs, mfiles in os_walk(self.MusikDir):
				for mname in mfiles:
					if mname.endswith(".mp3"):
						srvList.append(mname)
			if (len(srvList)>2):
				rndSrvIndex = randint(0, (len(srvList)-1))
				rndService = self.MusikDir + str(srvList[rndSrvIndex])
				nextService = eServiceReference("4097:0:0:0:0:0:0:0:0:0:" + rndService)
				return nextService
			else:
				return None
		else:
			return None
	
	def showRandomPicture(self):
		if (self.PicDir is not None) and (self.MusikDir is not None):
			self.NextPicTimer.stop()
			picList = []
			for root, dirs, files in os_walk(self.PicDir):
				for name in files:
					if (name.endswith(".jpg") or name.endswith(".jpeg")):
						picList.append(name)
			if (len(picList)>2):
				rndPicIndex = randint(0, (len(picList)-1))
				rndPicture = self.PicDir + str(picList[rndPicIndex])
				self.EXpicload.startDecode(rndPicture)
			else:
				self.PartyEnd()
			self.NextPicTimer.start(15000, True)
		else:
			self.PartyEnd()

	
	def DecodeAction(self, pictureInfo=""):
		ptr = self.EXpicload.getData()
		self["Picture"].instance.setPixmap(ptr)










